﻿package { 
	import flash.net.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.display.*; 
	import BLEvent;
	
	public class EditorManager extends EventDispatcher {
		var sendconn:LocalConnection;
		var rcvconn:LocalConnection;
		var gldcmd,elcmd;
		var cursoroverbl:Boolean = false;
		var paused:Boolean = false;
		static public var MAX_DATA_SIZE:Number=40000;
		public var theroot:MovieClip;
		var blRc:Number;
		
		var connectString:String="BLConnectionRcv";

		function EditorManager(r) {
		    theroot=r;
		    
		    try {
			    var keyStr:String;
			    var valueStr:String;
			    var paramObj:Object = LoaderInfo(theroot.root.loaderInfo).parameters;
			    for (keyStr in paramObj) {
					if (keyStr=="blRc") {
						blRc=Number(paramObj[keyStr]);
					}
			    }
			} catch (error:Error) {
			}
			
			connectString+=blRc;
			
			sendconn = new LocalConnection();
            sendconn.addEventListener(StatusEvent.STATUS, onstatus);

			
			rcvconn = new LocalConnection();
			rcvconn.allowDomain("http://www.bonuslevel.org","http://bonuslevel.org","http://localhost");
			rcvconn.client = this;
			try {
                rcvconn.connect("BLEditorConnectionSnd"+blRc);
            } catch (error:ArgumentError) {
                trace("GameManager Can't connect...the connection name is already being used by another SWF");
            }
		}
		// Is called by the level manager, when your editor is loaded and the BL API is ready
		public function blInit():void {
			// You may implement this function
			// ...
		}
		// Is called by the level manager, when your editor is paused (put in background)
		public function blPause():void {
			// You may implement this function, if you extend it don't forget to call the super.blPause() method, for the paused=true line
    		// ...
    		paused=true;
		}
		// Is called by the level manager, when your editor is resumed (put in foreground)
		public function blResume():void {
			// You may implement this function, if you extend it don't forget to call the super.blResume() method, for the paused=false line
    		// ...
    		paused=false;
		}
		// Is called by the level manager, it's a request to show the welcome screen of your editor (means the editor is not currently editing any levels)
		public function blWelcome():void {
			// You may implement this function
			// ...
		}
		// This function is called by the level manager, not by you. You must implement this function and return the serialized data of the currently edited level.
		// It returns true and a String containing the data when the data of the current level were successfully serialized to a String.
		// It returns false and a String containing an error message when there has been a problem serializing the level data.
		public function blGetLvlData():void {

			// You must implement this function
			// ...
			
			var bytes:ByteArray=new ByteArray();
			bytes.writeUTFBytes("YOU MUST IMPLENT THE GETLVLDATA FUNCTION OF THE EDITOR MANAGER");
			sendLvlData(false,bytes);
			//sendLevelData{true,yourByteArray};
		}
		// data is a String containing the level data to be unserialized. data is the null string "" for a new level.
		// It returns true when the data were successfully interpreted as level data and when the level edition has started.
		// It returns a String containing an error message when there has been a problem and when it's not possible to edit the level.
		public function blEditLvl(data:ByteArray):void {
			
			// You must implement this function
			// ...

			sendEditResult(false,"YOU MUST IMPLENT THE EDITLVL FUNCTION OF THE EDITOR MANAGER");
			//sendEditResult(true,"");
		}
		// Don't modify this function
		private var dataStack:ByteArray;
		public function editLvl(cmd,data:ByteArray,packet_id:Number=0,packet_nb:Number=1):void {
			if (packet_id==0) dataStack=new ByteArray();
			dataStack.writeBytes(data);
			if (packet_id==packet_nb-1) {
				elcmd=cmd;
				var bytes:ByteArray = new ByteArray();
				bytes.writeBytes(dataStack);
				blEditLvl(bytes);
				dataStack=new ByteArray();
			}
		}
		// Don't modify this function
		public function getLvlData(cmd):void {
			gldcmd=cmd;
			blGetLvlData();
		}
		// Don't modify this function
		public function sendEditResult(res:Boolean,data:String):void {
			sendconn.send(connectString, "editLvlCbk", elcmd, res, data);
		}
		// Don't modify this function
		public function sendLvlData(res:Boolean,data:ByteArray):void {
			//MAX_DATA_SIZE, split in small blocks of data if necessary
			var packet_nb=Math.ceil(data.length/MAX_DATA_SIZE); if (packet_nb<=0) packet_nb=1;
			for (var i=0;i<packet_nb;i++) {
				var packet:ByteArray=new ByteArray();
				var startRead=i*MAX_DATA_SIZE;
				var readLength=MAX_DATA_SIZE;
				if (startRead+readLength>=data.length) readLength=data.length-startRead;
				packet.writeBytes(data,startRead,readLength);
				sendconn.send(connectString, "getLvlDataByteArrayCbk", gldcmd, res, packet, i, packet_nb);
			}
		}
		// Don't modify this function. You can call it to display a trace.
		// txt contains the String you want to trace
		// lvl, 0 for important, 1 for medium, 2 for info
		public function log(txt:String,lvl:Number):void {
			sendconn.send(connectString, "debug",txt,lvl);
		}
		// Don't modify this function. You can call it to display the main menu
		// cmd=-1 turn on the menu as it is. Other values for specific screens. Not yet defined.
		public function showMenu(cmd:Number):void {
			sendconn.send(connectString, "cmdShowMenu",cmd);
		}
		// Don't modify this function. You can call it to display the popup with an info text
		public function showInfo(txt:String):void {
			sendconn.send(connectString, "cmdShowInfo",txt);
		}
		// Don't modify this function
		public function getMgrVersion():void {
			sendconn.send(connectString, "setEditorManagerVersion", 3, 1);
		}
		// Don't modify this function
		// Call this method to know if the editor is paused (in background). The editor is paused when the player is playing or testing a level for example.
		public function isPaused():Boolean {
			return paused;
		}
		// Don't modify this function
		// You must call it when a mouse click is triggered in your swf, to know if you can use it or not.
		// When it returns true, the mouse cursor is over a BonusLevel menu or popup, thus you can't use the mouse click for your swf.
		public function cursorOverBLGUI():Boolean {
			return cursoroverbl;
		}
		// Don't modify this function
		public function setCursorOverBLGUI(b):void {
			cursoroverbl=b;
			if (!paused) dispatchEvent(new BLEvent("GUI",b)); //dont dispatch if the app is paused
		}
		private function onstatus(event:StatusEvent):void {
            switch (event.level) {
                case "status":
                    //trace("GameManager LocalConnection.send() succeeded");
                    break;
                case "error":
                    //trace("GameManager LocalConnection.send() failed");
                    break;
            }
        }
		// Don't modify this function
		public var gid:Number=-1;
		public var path:String="";
		public function initialize(g:Number,p:String):void {
			gid = g;
			path = p;
			blInit();
		}
		//Call this to get the path to extra resources (extra swf, images etc...)  you have uplaoded to the BL servers, you may want to load into your main swf.
		public function getExtraPath():String {
			return path;
		}
	}
	
}