﻿package {
	import flash.net.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.display.*; 
	import BLEvent;
	
	public class GameManager extends EventDispatcher {
		var sendconn:LocalConnection;
		var rcvconn:LocalConnection;
		var plcmd;
		var cursoroverbl:Boolean = false;
		var paused:Boolean = false;
		static public var MAX_DATA_SIZE:Number=40000;
		public var theroot:MovieClip;
		var blRc:Number;
		
		var connectString:String="BLConnectionRcv";
		
		function GameManager(r) {
			theroot=r;
			
			try {
			    var keyStr:String;
			    var valueStr:String;
			    var paramObj:Object = LoaderInfo(theroot.root.loaderInfo).parameters;
			    for (keyStr in paramObj) {
					if (keyStr=="blRc") {
						blRc=Number(paramObj[keyStr]);
					}
			    }
			} catch (error:Error) {
			}
			
			connectString+=blRc;
			
			sendconn = new LocalConnection();
            sendconn.addEventListener(StatusEvent.STATUS, onstatus);

			
			rcvconn = new LocalConnection();
			rcvconn.allowDomain("http://www.bonuslevel.org","http://bonuslevel.org","http://localhost");
			rcvconn.client = this;
			try {
                rcvconn.connect("BLPlayerConnectionSnd"+blRc);
            } catch (error:ArgumentError) {
                trace("GameManager Can't connect...the connection name is already being used by another SWF");
            }
        }
		// Is called by the level manager, when your game is loaded and the BL API is ready
		public function blInit():void {
			// You may implement this function
			// ...
		}
		// Is called by the level manager, when your game is paused (put in background)
		public function blPause():void {
			// You may implement this function, if you extend it don't forget to call the super.blPause() method, for the paused=true line
    		// ...
    		paused=true;
		}
		// Is called by the level manager, when your game is resumed (put in foreground)
		public function blResume():void {
			// You may implement this function, if you extend it don't forget to call the super.blResume() method, for the paused=false line
    		// ...
    		paused=false;
		}
		// Is called by the level manager, it's a request to show the welcome screen of your game (means there is not any level currently playing)
		public function blWelcome():void {
			// You may implement this function
			// ...
		}
		// Is called by the level manager when the player has just completed all levels of a category. You can implement a winning animation if you wish.
		public function blCatWin():void {
			// You may implement this function
			// ...
		}
		// Is called by the level manager when the player has just completed all levels of the game. You can implement a winning animation if you wish.
		public function blWin():void {
			// You may implement this function
			// ...
		}
		
		/*******************************************
		 * 
		 *  GAME BASIC API
		 * 
		 * *****************************************/
		
		// This function is called by the level manager, not by you. You must implement this function. At the end of the function, if it is successful, the player is playing the corresponding level.
		// data is a ByteArray  containing the level data to be unserialized.
		// official equals -1 if it's a testing of edited level, 0 if the level is not official, 1 if the level is official and has never been completed, 2 if the level is official but has already been completed
		// It returns true when the data were successfully interpreted as level data and when levels is currently playing.
		// It returns a String containing an error message when there has been a problem and when it's not possible to play the level.
		public function blPlayLvl(data:ByteArray,official:Number):void {

			// You must implement this function
			// ...

			sendPlayResult(false,"YOU MUST IMPLEMENT THE blPlayLvl FUNCTION OF THE GAME MANAGER");
			//sendPlayResult(true,"");
		}
		// Don't modify this function
		// You must call it when the player has completed a level and want to go to the next one.
		// completed is true or false. If the level is not completed (false) when calling this function you switch to the next level (if you choose not to lock levels in the bonuslevel.org game parameters).
		// score is the score of the player for this level.
		// Returne true is success or a message to display if not.
		public function lvlCompleted(completed:Boolean,score:Number):void {
			sendconn.send(connectString, "lvlCompleted", completed,score);
		}
		
		/*******************************************
		 * 
		 *  USER DATA API
		 * 
		 * *****************************************/
		
		// This function is called by the level manager after you have requested for the user data.
		// data is a byteArray  containing the user data. User data can be a list of items, power ups, coins etc.. the user has grabbed along the game and the levels.
		// If res is false, data is a string containing an error message.
		public function blNewUserData(res:Boolean,data:ByteArray):void {

			// You may implement this function
			// ...

		}
		// Don't modify this function
		// You must call it, usually at the begining of the game, if your game implements the user data. (items, power ups that you want to keep in memory levels after levels)
		// When you call this functin, you request for the level data..
		// The BL API will reply to the request with by calling the blNewUserData function. Then the blNewUserData function will be called each time the player slot changes (player 1, player 2 etc..). If the player is a bl member, this will not happen (because the user data are save on bl servers ad not on local slot).
		public function requestUserData():void {
			sendconn.send(connectString, "requestUserData");
		}
		// Don't modify this function
		// You must call it to store the user data (items, money etc...). The BL API will reply with userDataUpdatedCbk();
		public function updateUserData(data:ByteArray):void {
			//MAX_DATA_SIZE, split in small blocks of data if necessary
			var packet_nb=Math.ceil(data.length/MAX_DATA_SIZE); if (packet_nb<=0) packet_nb=1;
			for (var i=0;i<packet_nb;i++) {
				var packet:ByteArray=new ByteArray();
				var startRead=i*MAX_DATA_SIZE;
				var readLength=MAX_DATA_SIZE;
				if (startRead+readLength>=data.length) readLength=data.length-startRead;
				packet.writeBytes(data,startRead,readLength);
				sendconn.send(connectString, "updateUserDataByte", packet, i, packet_nb);
			}
		}
		// This function is called by the BL API after you call updateUserData.
		// If res is true, the user data has been stored successfully
		// If res is false, there has been an error. In that case, data is the the error message.
		public function userDataUpdatedCbk(res:Boolean,data:String):void {
		
			// You may implement this function
			// ...
			
		}
		
		/*******************************************
		 * 
		 *  BEST PLAYER DATA API (since v2 only)
		 * 
		 * *****************************************/
		
		// This function is called by the level manager after you have requested for the best player data.
		// data is a byteArray  containing the best player data. For example, this data can contain the description of a replay of the best player for a racing game.
		// If res is false, data is a string containing an error message.
		public function blBestPlayerData(res:Boolean, username:String, score:Number , data:ByteArray):void {

			// You may implement this function
			// ...

		}
		// Don't modify this function
		// You must call it, usually at the begining of the game, if your game implements the user data. (items, power ups that you want to keep in memory levels after levels)
		// When you call this function, you request for the best player data.
		// The BL API will reply to the request with by calling the blBestPlayerData method. Unlike requestUserData, blBestPlayerData is only called once after you call the request method requestBestPlayerData.
		public function requestBestPlayerData():void {
			sendconn.send(connectString, "requestBestPlayerData");
		}
		// Don't modify this function
		// You must call this method when the BL Manager call the method blNeedBestPlayerData();
		public function sendBestPlayerData(data:ByteArray):void {
			//MAX_DATA_SIZE, split in small blocks of data if necessary
			var packet_nb=Math.ceil(data.length/MAX_DATA_SIZE); if (packet_nb<=0) packet_nb=1;
			for (var i=0;i<packet_nb;i++) {
				var packet:ByteArray=new ByteArray();
				var startRead=i*MAX_DATA_SIZE;
				var readLength=MAX_DATA_SIZE;
				if (startRead+readLength>=data.length) readLength=data.length-startRead;
				packet.writeBytes(data,startRead,readLength);
				sendconn.send(connectString, "sendBestPlayerDataByte", packet, i, packet_nb);
			}
		}
		// This function is called by the level manager after you have complete a level and if you achieved the best score.
		// If your game implements the BEST PLAYER DATA API, then you have to serialize the best player data and end it to the BL Manager with the method sendBestPlayerData.
		// If your game doesn't imlpemnt the BEST PLAYER DATA API, just leave the method unchanged (the BL manager will receive a null object which means the API is not implemented).
		public function blNeedBestPlayerData():void {

			// You may implement this function if you wish to use the BEST PLAYER DATA API
			// ...
			sendconn.send(connectString, "sendBestPlayerDataByte", null, 0, 0);

		}
		
		/*******************************************
		 * 
		 *  HIDDEN API (not to be used)
		 * 
		 * *****************************************/
		
		// Don't modify this function
		private var dataStack:ByteArray;
		public function playLvl(cmd,data:ByteArray,official:Number,packet_id:Number=0,packet_nb:Number=1):void {
			if (packet_id==0) dataStack=new ByteArray();
			dataStack.writeBytes(data);
			if (packet_id==packet_nb-1) {
				plcmd=cmd;
				var bytes:ByteArray=new ByteArray();
				bytes.writeBytes(dataStack);
				blPlayLvl(bytes,official);
				dataStack=new ByteArray();
			}
		}
		// Don't modify this function
		public function sendPlayResult(res:Boolean,data:String):void {
			sendconn.send(connectString, "playLvlCbk", plcmd, res, data);
		}
		// Don't modify this function
		private var userDataStack:ByteArray;
		public function newUserData(res:Boolean,data:ByteArray,packet_id:Number=0,packet_nb:Number=1):void {
			//log("newUserData ["+res+"] data.length=["+data.length+"] packed_id=["+packet_id+"] packet_nb=["+packet_nb+"]",1);
			if (packet_id==0) userDataStack=new ByteArray();
			userDataStack.writeBytes(data);
			if (packet_id==packet_nb-1) {
				var bytes:ByteArray = new ByteArray();
				bytes.writeBytes(userDataStack);
				blNewUserData(res,bytes);
				userDataStack=new ByteArray();
			}
		}
		// Don't modify this function
		private var bestPlayerDataStack:ByteArray;
		public function bestPlayerData(res:Boolean,username:String,score:Number,data:ByteArray,packet_id:Number=0,packet_nb:Number=1):void {
			//log("bestPlayerData ["+res+"] data.length=["+data.length+"] packed_id=["+packet_id+"] packet_nb=["+packet_nb+"]",1);
			if (packet_id==0) bestPlayerDataStack=new ByteArray();
			bestPlayerDataStack.writeBytes(data);
			if (packet_id==packet_nb-1) {
				var bytes:ByteArray = new ByteArray();
				bytes.writeBytes(bestPlayerDataStack);
				blBestPlayerData(res,username,score,bytes);
				bestPlayerDataStack=new ByteArray();
			}
		}
		
		/*******************************************
		 * 
		 *  UTILS/MISC API
		 * 
		 * *****************************************/
		
		// Don't modify this function. You can call it to display a trace.
		// txt contains the String you want to trace
		// lvl, 0 for important, 1 for medium, 2 for info
		public function log(txt:String,lvl:Number):void {
			sendconn.send(connectString, "debug",txt,lvl);
		}
		// Don't modify this function. You can call it to display the main menu
		// cmd=-1 turn on the menu as it is. Other values for specific screens. Not yet defined.
		public function showMenu(cmd:Number):void {
			sendconn.send(connectString, "cmdShowMenu",cmd);
		}
		// Don't modify this function. You can call it to display the popup with an info text
		public function showInfo(txt:String):void {
			sendconn.send(connectString, "cmdShowInfo",txt);
		}
		// Don't modify this function
		// v1 (2007) : Creation
		// v2 (08/2008) : Add of Best Play Data methods
		public function getMgrVersion():void {
			sendconn.send(connectString, "setPlayerManagerVersion", 3, 2);
		}
		// Don't modify this function
		// Call this method to know if the game is paused (in background). The game is paused when the player is editing a level for example.
		public function isPaused():Boolean {
			return paused;
		}
		// Don't modify this function
		// You must call it when a mouse click is triggered in your swf, to know if you can use it or not.
		// When it returns true, the mouse cursor is over a BonusLevel menu or popup, thus you can't use the mouse click for your swf.
		public function cursorOverBLGUI():Boolean {
			return cursoroverbl;
		}
		// Don't modify this function
		public function setCursorOverBLGUI(b):void {
			cursoroverbl=b;
			if (!paused) dispatchEvent(new BLEvent("GUI",b)); //dont dispatch if the app is paused
		}
		private function onstatus(event:StatusEvent):void {
            switch (event.level) {
                case "status":
                    //trace("GameManager LocalConnection.send() succeeded");
                    break;
                case "error":
                    //trace("GameManager LocalConnection.send() failed");
                    break;
            }
        }
		// Don't modify this function
		public var gid:Number=-1;
		public var path:String="";
		public function initialize(g:Number,p:String):void {
			gid = g;
			path = p;
			blInit();
		}
		//Call this to get the path to extra resources (extra swf, images etc...)  you have uplaoded to the BL servers, you may want to load into your main swf.
		public function getExtraPath():String {
			return path;
		}
	}
}