﻿package {
	import flash.utils.*;
	public class MyUserDataGameManager extends MyGameManager {
		// MyUserDataGameManager is an example of implementation of the basic level API (decribed in MyGameManager.as) AND also the user data API
		// User data API allows you to save custom user data (items, progression, power, strength, money etc...), while the player completes levels.
		function MyUserDataGameManager(r) {
			super(r);
			requestUserData(); // We inform the API that we want to receive the user data. BL API will call blUserData in response, the first time and each time the player slot is modified.

			//////////////////////////////////////////////////////////////////////////////////////////////////////
			// During the game session, you have to call updateUserData(data:ByteArray) when you want to save the new player data.
			// For example, the user have just completed an official level for the first time, and he wins 1000 gold coins. Then you can serialize the new user data and call updateUserData(data:ByteArray).
			// He goes to the shop and buys a powerful weapon. Then you can serialize again the new user data and call updateUserData(data:ByteArray).
			//////////////////////////////////////////////////////////////////////////////////////////////////////
		}
		
		override public function blNewUserData(res:Boolean,data:ByteArray):void {
			// You may implement this function
			// Store the user data in memory, show a user CPanel etc...
			//theroot.addMsg("MyUserDataGameManager blNewUserData ["+res+"]["+data.length+"]") //debug
			if (res) theroot.unserializeAndShowUserData(data);
			else {
				// Show error...
				// TODO...
				theroot.addMsg(data.toString());
			}
		}
		
		
		// This function is called by the BL API after you call updateUserData.
		// If res is true, the user data has been stored successfully
		// If res is false, there has been an error. In that case, data is the the error message.
		override public function userDataUpdatedCbk(res:Boolean,data:String):void {
			// You may implement this function
			// ...
			if (!res) {
				// Show error...
				// TODO...
				theroot.addMsg(data.toString());
			}
		}
		/* tests
		override public function blInit():void {
			theroot.addMsg("blInit")
		}
		override public function blPause():void {
		    super.blPause();
			theroot.addMsg("blPause")
		}
		override public function blResume():void {
		    super.blResume();
			theroot.addMsg("blResume")
		}
		*/
	}
}